#include<stdio.h>
#include<iostream>
#include <string>

typedef enum {
	CLOCKWISE = 0,
    ANTICLOCKWISE = 1
} Spin;

typedef enum {
	EAST = 0,
	SOUTH = 1,
	WEST = 2,
	NORTH = 3
} Directions;

void printLevel(int** level, int gridSize, Directions direction, Spin spin, bool highCorners) {
	printf("Grid : %dx%d\nDirection : ", gridSize, gridSize);
	switch (direction) {
	case EAST:
		printf("East\n");
		break;
	case SOUTH:
		printf("South\n");
		break;
	case WEST:
		printf("West\n");
		break;
	case NORTH:
		printf("North\n");
		break;
	}
	switch (spin)
	{
	case CLOCKWISE:
		printf("Spin : Clockwise\n");
		break;
	case ANTICLOCKWISE:
		printf("Spin : Anti Clockwise\n");
		break;
	}
	if (highCorners) {
		printf("Corners : Contains max values\n");
	}
	for (int x = 0; x < gridSize; x++) {
		for (int y = 0; y < gridSize; y++) {
			printf("%3d ", level[x][y]);
		}
		printf("\n");
	}
}

void swapCorners(int** level, int gridSize, int xyOffset) {
	int maxNum = gridSize * gridSize - 3;
	int corner = 0; //0 Bottom Left, 1 Top Left, 2 Top Right, 3 Bottom Right
	while (maxNum <= (gridSize * gridSize)) {
		for (int x = 0; x < gridSize; x++) {
			for (int y = 0; y < gridSize; y++) {
				if (maxNum == level[xyOffset + x][xyOffset + y] && corner < 4) {
					int temp;
					if (corner == 0) {
						temp = level[xyOffset + gridSize - 1][xyOffset];
						level[xyOffset + gridSize - 1][xyOffset] = maxNum;
					}else if(corner == 1) {
						temp = level[xyOffset][xyOffset];
						level[xyOffset][xyOffset] = maxNum;
					}
					else if (corner == 2) {
						temp = level[xyOffset][xyOffset + gridSize - 1];
						level[xyOffset][xyOffset + gridSize - 1] = maxNum;
					}
					else if(corner == 3) {
						temp = level[xyOffset + gridSize - 1][xyOffset + gridSize - 1];
						level[xyOffset + gridSize - 1][xyOffset + gridSize - 1] = maxNum;
					}				
					level[xyOffset + x][xyOffset + y] = temp;
					maxNum = maxNum + 1;
					corner = corner + 1;					
				}
			}
		}
	}
}

int getTopLeftValueAntiClockwise(int gridSize, Directions direction) {
	int value = 0;
	int numberOfCellsInTheBorder = (gridSize * 4) - 4;
	int startingNumberInTheBorder = (gridSize * gridSize) - numberOfCellsInTheBorder + 1;
	switch (direction)
	{
	case EAST:
		value = startingNumberInTheBorder + (1 * gridSize) - 1 + (gridSize / 2);
		break;
	case SOUTH:
		value = startingNumberInTheBorder + (2 * gridSize) - 2 + (gridSize / 2);
		break;
	case WEST:
		value = startingNumberInTheBorder + (3 * gridSize) - 3 + (gridSize / 2);
		break;
	case NORTH:
		value = startingNumberInTheBorder + gridSize / 2;
		break;
	}
	return value;
}

int getTopLeftValue(int gridSize, Directions direction) {
	int value = 0;
	int numberOfCellsInTheBorder = (gridSize * 4) - 4;
	int startingNumberInTheBorder = (gridSize * gridSize) - numberOfCellsInTheBorder + 1;
	switch (direction)
	{
	case EAST:
		value = startingNumberInTheBorder + (2 * gridSize) - 2 + (gridSize / 2);
		break;
	case SOUTH:
		value = startingNumberInTheBorder + (1 * gridSize) - 1 + (gridSize / 2);
		break;
	case WEST:
		value = startingNumberInTheBorder + (gridSize / 2);
		break;
	case NORTH:
		value = startingNumberInTheBorder + (3 * gridSize) - 3 + (gridSize / 2);
		break;
	}
	return value;
}

void fillBorderAntiClockwise(int** level, int gridSize, Directions direction, int xyOffset) {
	int x, y;
	int topLeftValue = getTopLeftValueAntiClockwise(gridSize, direction);
	int numberOfCellsInTheBorder = (gridSize * 4) - 4;
	int startingNumberInTheBorder = (gridSize * gridSize) - numberOfCellsInTheBorder + 1;
	int value = topLeftValue;
	int bottomLeft;
	int topRight;
	// Top Row
	for (y = 0; y < gridSize; y++) {
		if (value < startingNumberInTheBorder) {
			value = (gridSize * gridSize);
		}
		level[xyOffset][xyOffset + y] = value--;
	}
	topRight = value;
	//First Column
	value = topLeftValue + 1;
	for (x = 1; x < gridSize; x++) {
		if (value >(gridSize * gridSize)) {
			value = startingNumberInTheBorder;
		}
		level[xyOffset + x][xyOffset] = value++;
	}
	bottomLeft = value;
	//Bottom Row
	value = bottomLeft;
	for (y = 1; y < gridSize; y++) {
		if (value >(gridSize * gridSize)) {
			value = startingNumberInTheBorder;
		}
		level[xyOffset + gridSize - 1][xyOffset + y] = value++;
	}
	// Last Column
	value = topRight;
	for (x = 1; x < gridSize; x++) {
		if (value < startingNumberInTheBorder) {
			value = (gridSize * gridSize);
		}
		level[xyOffset + x][xyOffset + gridSize - 1] = value--;
	}
}

void fillBorder(int** level, int gridSize, Directions direction, int xyOffset) {
	int x, y;
	int topLeftValue = getTopLeftValue(gridSize, direction);
	int numberOfCellsInTheBorder = (gridSize * 4) - 4;
	int startingNumberInTheBorder = (gridSize * gridSize) - numberOfCellsInTheBorder + 1;
	int value = topLeftValue;
	int bottomLeft;
	int topRight;
	// Top Row
	for (y = 0; y < gridSize; y++) {
		if (value >(gridSize * gridSize)) {
			value = startingNumberInTheBorder;
		}
		level[xyOffset][xyOffset + y] = value++;
	}
	topRight = value;
	//First Column
	value = topLeftValue - 1;
	for (x = 1; x < gridSize; x++) {
		if (value < startingNumberInTheBorder) {
			value = (gridSize * gridSize);
		}
		level[xyOffset + x][xyOffset] = value--;
	}
	bottomLeft = value;
	//Bottom Row
	value = bottomLeft;
	for (y = 1; y < gridSize; y++) {
		if (value < startingNumberInTheBorder) {
			value = (gridSize * gridSize);
		}
		level[xyOffset + gridSize - 1][xyOffset + y] = value--;
	}
	// Last Column
	value = topRight;
	for (x = 1; x < gridSize; x++) {
		if (value >(gridSize * gridSize)) {
			value = startingNumberInTheBorder;
		}
		level[xyOffset + x][xyOffset + gridSize - 1] = value++;
	}
}

int** generateLevel(int gridSize, Directions direction, Spin spin, bool highValueCorners) {
	if (gridSize % 2 == 0) {
		std::cout << "Grid Size needs to be odd." << std::endl;
		return nullptr;
	}

	int **level = (int**)malloc(sizeof(int*) * gridSize);
	for (int i = 0; i < gridSize; i++) {
		level[i] = (int*)malloc(sizeof(int) * gridSize);
	}

	int currentGridSize = gridSize;
	int xyOffset = 0;
	while (currentGridSize > 1) {
		if (spin == ANTICLOCKWISE) {
			fillBorderAntiClockwise(level, currentGridSize, direction, xyOffset);
		}
		else {
			fillBorder(level, currentGridSize, direction, xyOffset);
		}
		if (highValueCorners) {
			swapCorners(level, currentGridSize, xyOffset);
		}
		xyOffset++;
		currentGridSize = currentGridSize - 2;
	}
	level[gridSize / 2][gridSize / 2] = 1;	
	printLevel(level, gridSize, direction, spin, highValueCorners);
	return level;
}

int main(int argc, char** argv) {
	int gridSize = 5;
	Spin spin = CLOCKWISE;
	Directions direction = NORTH;
	bool highValueCorners = false;
	if (argc > 1) {
		if (std::stoi(argv[1]) % 2 != 1) {
			std::cout << "Error: Grid number needs to be odd\n";
			return -1;
		}
		if ((argc > 2) && (std::stoi(argv[2]) < 1 || std::stoi(argv[2]) > 4)) {
			std::cout << "Error: Direction can be 1-4. 1-EAST, 2-SOUTH, 3-WEST, 4-NORTH\n";
			return -1;
		}
		if ((argc > 3) && (std::stoi(argv[3]) < 1 || std::stoi(argv[3]) > 2)) {
			std::cout << "Error: Spin can be 1-2. 1-Clockwise, 2-Anti Clockwise\n";
			return -1;
		}
		if ((argc > 3) && (std::stoi(argv[3]) < 1 || std::stoi(argv[3]) > 2)) {
			std::cout << "Error: Spin can be 1-2. 1-Clockwise, 2-Anti Clockwise\n";
			return -1;
		}
		if ((argc > 4) && (std::stoi(argv[4]) < 1 || std::stoi(argv[4]) > 2)) {
			std::cout << "Error: Corners to have high values can be 1-2. 1-Normal, 2-Corner to have high values\n";
			return -1;
		}
		gridSize = argc > 1 ? std::stoi(argv[1]): 5;
		direction = argc > 2 ? (Directions)(std::stoi(argv[2]) - 1) : NORTH;
		spin = argc > 3 ? (Spin)(std::stoi(argv[3]) - 1) : CLOCKWISE;
		if ((argc > 4) && (std::stoi(argv[4]) == 2)) {
			highValueCorners = true;
		}
	}
	else {
		printf("Usage:\nGenerateSpiralGrid <number Of grids> <Direction> <SPIN> <Corner Special Case>\nWhere");
		printf("\t <number Of grids>     -> Any odd Number\n");
		printf("\t <Direction>           -> can be 1-4. 1-EAST, 2-SOUTH, 3-WEST, 4-NORTH\n");
		printf("\t <SPIN>                -> can be 1-2. 1-Clockwise, 2-Anticlockwise\n");
		printf("\t <Corner Special Case> -> can be 1-2. 1-Normal, 2-Corners will have max values.\n\n");
	}	

	generateLevel(gridSize, direction, spin, highValueCorners);
}
